#!/bin/bash 

#
# Copyright (c) Members of the EGEE Collaboration. 2004.
# See http://www.eu-egee.org/partners/ for details on the copyright holders.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# 
#  GLite Data Transfer Scripts
#
#  Authors: Paolo Badino <paolo.badino@cern.ch>
#  Version info: $Id: channel-day-report.sh,v 1.5 2007/03/26 15:38:11 badino Exp $
#  Release: $Name:  $
#
#

# Check that GLITE_LOCATION is set
if [ "x$GLITE_LOCATION" == "x" ] ; then
    if [ -e /etc/profile.d/gliteenv.sh ]; then
        source /etc/profile.d/gliteenv.sh
    fi
    if [ "x$GLITE_LOCATION" == "x" ] ; then
        echo "GLITE_LOCATION Environemnt variable is not set. Please fix your profile";
        exit -1;
    fi
fi

# Report Type & category
REPORT_CATEGORY=channel
REPORT_TYPE=transfer
REPORT_INTERVAL=day
REPORT_REL_DIR=`date +'%Y/%m'`

# Import Common functions
source $GLITE_LOCATION/share/glite-data-transfer-scripts/reports/report-common.sh

# Generate report
make_report

# Generate html
make_html
