// Check if a property of an object is defineed is define
function is_defined(obj) {
    return (typeof(obj) == 'undefined')? false: true;
}
// check if an element is collapsed
function is_collapsed(element){
    if((navigator.appName == "Microsoft Internet Explorer") ||
       (-1 != navigator.userAgent.indexOf("Safari"))){
        // Fix fox internet explorer
        if(is_defined(element.style.display) &&
           (element.style.display == 'none')){
            return true;
        }
    } else{
        if(element.style.visibility == 'collapse'){
            return true;
        }
    }
    return false;
}
// check if the visibility of an element is set
function is_visibility_set(element){
    if((navigator.appName == "Microsoft Internet Explorer") ||
       (-1 != navigator.userAgent.indexOf("Safari"))){
        // Fix fox internet explorer
        return true;
    } else{
        if(element.style.visibility != ''){
            return true;
        }
    }
    return false;
}
// collapse an element
function collapse(element){
    if((navigator.appName == "Microsoft Internet Explorer") ||
       (-1 != navigator.userAgent.indexOf("Safari"))){
        // Fix fox internet explorer
        element.style.display = 'none';
    } else{
        element.style.visibility = 'collapse';
    }
}
// make an element visible
function make_visible(element){
    if((navigator.appName == "Microsoft Internet Explorer") ||
       (-1 != navigator.userAgent.indexOf("Safari"))){
        // Fix fox internet explorer
        element.style.display = '';
    } else{
        element.style.visibility = 'visible';
    }
}
// Fix display features
function fix_visibility(){
    if((navigator.appName == "Microsoft Internet Explorer") ||
       (-1 != navigator.userAgent.indexOf("Safari"))){
        // Fix fox internet exprorer
        show_all();
        hide_all();
    }
}
// Fix alpha transparency of a PNG image 
// (see http://homepage.ntlworld.com/bobosola/pnginfo.htm)
function fix_png_alpha(img) {
    if(navigator.appName == "Microsoft Internet Explorer"){
       var arVersion = navigator.appVersion.split("MSIE")
       var version = parseFloat(arVersion[1])

       if ((version >= 5.5) && (version < 7) && (document.body.filters)){
           var imgID = (img.id) ? "id='" + img.id + "' " : "";
	   var imgClass = (img.className) ? "class='" + img.className + "' " : "";
	   var imgTitle = (img.title) ? 
		             "title='" + img.title  + "' " : "title='" + img.alt + "' ";
	   var imgStyle = "display:inline-block;" + img.style.cssText;
	   var strNewHTML = "<span " + imgID + imgClass + imgTitle
                  + " style=\"" + "width:" + img.width 
                  + "px; height:" + img.height 
                  + "px;" + imgStyle + ";"
                  + "filter:progid:DXImageTransform.Microsoft.AlphaImageLoader"
                  + "(src=\'" + img.src + "\', sizingMethod='scale');\"></span>";
	   img.outerHTML = strNewHTML;
        }
    }
}

// Change the visibility of the VO rows
function toggle_display(name){
    var elements;
    if(navigator.appName == "Microsoft Internet Explorer"){
        elements = document.getElementsByTagName('TR')
        if(elements.length > 0){
            for(i = 0; i < elements.length; ++i){
                var elem = elements.item(i);
                if(is_defined(elem.getAttribute('name')) &&
                   (elem.getAttribute('name') == name)){
                    if((is_visibility_set(elem) == false) ||
                       (is_collapsed(elem) == true)){
                        make_visible(elem);
                    } else {
                        collapse(elem);
                    }
                }
            }
        }
    } else {
        var elements = document.getElementsByName(name);
        for(i in elements){
            if((is_visibility_set(elements[i]) == false) ||
              (is_collapsed(elements[i]) == true)){
                make_visible(elements[i]);
            } else {
                collapse(elements[i]);
            }
        }
    }
}
// Shows all VO details
function show_all(){
    show_rows(true);
}
// Hide all VO Details
function hide_all(){
    show_rows(false);
}
// Toggle visibility of VO details
function show_rows(show){
    var report_table = document.getElementById('report_table');
    // Get all the rows
    var rows = report_table.rows;
    var channel_visible = true;
    for(var i in rows){
        // Skip the first row
        if(i == 0){
            continue;
        }
        // consider only the channel rows
        if(rows[i].tagName == 'TR'){
            if(rows[i].childNodes[1].innerHTML == '[All]'){
                // Check if the channel is visible
                if(is_collapsed(rows[i])){
                    channel_visible = false;
                } else {
                    channel_visible = true;
                } 
            } else if(channel_visible == true) {
                if(show == true){
                   make_visible(rows[i]);
                } else {
                   collapse(rows[i]);
                }
           }
        }
    }
    // Toggle button visibility
    var show_button = document.getElementById('show_all');
    if(show == true){
        show_button.innerHTML="Hide VO details";
        show_button.onclick=hide_all;
    } else {
        show_button.innerHTML="Show VO details";
        show_button.onclick=show_all;
    }
}
function filter_channels(pattern){
    // Hide all rows
    hide_all();
    // Create Regular Expression
    var reg_ex;
    if(pattern.length != 0){
        reg_ex = new RegExp(pattern);
    }
    // Get table
    var report_table = document.getElementById('report_table');
    // Get all the rows
    var rows = report_table.rows;
    for(var i in rows){
        // Skip the first row
        if(i == 0){
            continue;
        }
        // consider only the channel rows
        if((rows[i].tagName == 'TR') &&
           (rows[i].childNodes[1].innerHTML == '[All]')){
           var channel_name = rows[i].childNodes[0].childNodes[0].innerHTML;
           if(reg_ex == undefined || reg_ex.test(channel_name)){
               make_visible(rows[i]);
           } else {
               collapse(rows[i]);
           }
        }
    }
}

